# Interface MapBinnedData.BinMapper<K extends Comparable<K>>

Enclosing class:
  `MapBinnedData<K extends Comparable<K>>`

public static interface MapBinnedData.BinMapper<K extends Comparable<K>>
Defines the mapping of numerical values to map keys. The keys must implement `equals` and `hashCode` properly.

Since:
  14 Nov 2005
Author:
  Mark Taylor

## Method Summary

Modifier and Type
Method
Description
`MapBinnedData<K>`
`createBinnedData(int nset)`
Creates a BinnedData instance based on this mapper.
`double[]`
`getBounds(K key)`
Returns the upper and lower bounds of the bin corresponding to a given key.
`K`
`getKey(double value)`
Returns the key to use for a given value.
`Iterator<K>`
`keyIterator(K loKey, K hiKey)`
Returns an iterator which covers all keys between the given low and high keys inclusive.

## Method Details

### getKey

K getKey(double value)
Returns the key to use for a given value. May return `null` to indicate that the given value cannot be binned.

Parameters:
  `value` - numerical value
Returns:
  object to be used as a key for the bin into which `value` falls

### getBounds

double[] getBounds(K key)
Returns the upper and lower bounds of the bin corresponding to a given key.

Parameters:
  `key` - bin key object
Returns:
  2-element array giving (lower,upper) bound for bin `key`

### keyIterator

Iterator<K> keyIterator(K loKey, K hiKey)
Returns an iterator which covers all keys between the given low and high keys inclusive. `loKey` and `hiKey` must be possible keys for this mapper and arranged in the right order.

Parameters:
  `loKey` - lower bound (inclusive) for key iteration
  `hiKey` - upper bound (inclusive) for key iteration
Returns:
  iterator

### createBinnedData

MapBinnedData<K> createBinnedData(int nset)
Creates a BinnedData instance based on this mapper.

Parameters:
  `nset` - the number of subsets that the BinnedData can deal with
Returns:
  binned data instance